﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Windows.Controls;

namespace AutoCompleteBoxWpf
{
    public class CustomFilteringBehavior : FilteringBehavior
    {
        public override IEnumerable<object> FindMatchingItems(string searchText, System.Collections.IList items, IEnumerable<object> escapedItems, string textSearchPath, TextSearchMode textSearchMode)
        {
            IEnumerable<object> countriesWithMatchingItems = null;

            if (textSearchMode == TextSearchMode.Contains)
            {
                countriesWithMatchingItems = items.OfType<Country>().Where(x => x.ChildItems != null && x.ChildItems.Any(i => i.Contains(searchText)));
            }

            var result = countriesWithMatchingItems.SelectMany(x => (x as Country).ChildItems).Where(c => c.Contains(searchText));

            return result;
        }
    }
}
